//---------------------------------------------------------------
//
//  Ce code est librement inspiré de celui de Gabriel STOLTZ (Ecole des Ponts)
//
//---------------------------------------------------------------

//---------------------------------------------------------------------
//
//           !! ATTENTION !! 
// pour voir l'orthogonalité de -\nabla V aux lignes de niveau,
// il faut un peu modifier la taille de la boite pour avoir un carré
// = même métrique en x et en y (repere **orthonorme**)
//
//---------------------------------------------------------------------

clf();
xset("fpf"," ");

//------ pour les traces -------
//-- for gradient field --
dx = 0.2;
dy = 0.2;
arrow_size = 0.8;
signe = 1;
//-- for contour --
dx_c = 0.01;
dy_c = 0.01;
//-- bounds --
Rx = 2.5;
Ry = 2.5;

//-------- fonction à étudier -------------

function z = V(x,y)
   z = (x^3 + y^2)*exp(-(x^2+y^2));
endfunction

function dxV = nabla_x_V(x,y)
  dxV = 3*(x^2)*exp(-(x^2+y^2)) - 2*x*(x^3+y^2)*exp(-(x^2+y^2));
endfunction

function dyV = nabla_y_V(x,y)
  dyV = 2*y*exp(-(x^2+y^2)) - 2*y*(x^3+y^2)*exp(-(x^2+y^2));
endfunction

//-------- trace de -\nabla V -------------

x = -Rx:dx:Rx;
y = -Ry:dy:Ry; 
DxV = feval(x,y,nabla_x_V);
DyV = feval(x,y,nabla_y_V);
champ(x,y,signe*DxV,signe*DyV,arfact=arrow_size); // artfact = size of arrow
// use champ1 for colors on the arrows

//------ trace du contour --------

x = -Rx:dx_c:Rx;
y = -Ry:dy_c:Ry;
z = feval(x,y,V);
contour2d(x,y,z,20,rect=[-Rx,-Ry,Rx,Ry]);
f = gcf(); //get the handle of the parent figure
f.color_map = jetcolormap(24);
a = gca(); //get current axes
a.isoview = "on";
